//+------------------------------------------------------------------+
//|                                        AbsoluteStrength_v1.1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_width1     2 
#property indicator_color2     Red
#property indicator_width2     2
#property indicator_color3     Green
#property indicator_width3     1
#property indicator_style3     3 
#property indicator_color4     Crimson
#property indicator_width4     1 
#property indicator_style4     3
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enAsMethod
{
   as_rsi,  // RSI methos
   as_sto,  // Stochastic method
   as_adx   // ADX method
};
extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern enAsMethod      Mode        = as_sto;
extern double          Length      = 20;  
extern double          Signal      = 10;  
extern double          T3Hot       = 1.0;
extern bool            T3Original  = false;
extern bool            T3Adaptive  = false;
extern enPrices        Price       = pr_close;   
extern double          OverBought  = 0; 
extern double          OverSold    = 0;  
extern bool            Interpolate = true;
  
//
//
//
//
//

double Bulls[];
double Bears[];
double SmthBulls[];
double SmthBears[];
double SigBulls[];
double SigBears[];
double prices[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   IndicatorBuffers(7);
   SetIndexBuffer(0,SmthBulls); SetIndexLabel(0,"Bulls");
   SetIndexBuffer(1,SmthBears); SetIndexLabel(1,"Bears");                   
   SetIndexBuffer(2,SigBulls);  SetIndexLabel(2,"SignalBulls");
   SetIndexBuffer(3,SigBears);  SetIndexLabel(3,"SignalBears");  
   SetIndexBuffer(4,Bulls);
   SetIndexBuffer(5,Bears);
   SetIndexBuffer(6,prices);
   SetLevelValue(0,0);
   
   //
   //
   //
   //
   //
       
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == -99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      string add = "RSI";
         if (Mode==as_sto) add = "stochastic";
         if (Mode==as_adx) add = "adx";
   IndicatorShortName(timeFrameToString(TimeFrame)+  " T3 Absolute strength "+add+" mode("+Mode+","+DoubleToStr(Length,2)+","+DoubleToStr(Signal,2)+")");
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { SmthBulls[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == _Period)
   {
   
     for (int i=limit; i>=0; i--)
     {
         prices[i] = getPrice(Price,Open,Close,High,Low,i); 
         double Price1 = prices[i];
         double Price2 = prices[i+1];
      
         switch (Mode)
         {
            case as_rsi : 
               Bulls[i] = 0.5*(MathAbs(Price1-Price2)+(Price1-Price2));
               Bears[i] = 0.5*(MathAbs(Price1-Price2)-(Price1-Price2));
               break;
            case as_sto:        
               double smax  = High[Highest(NULL,0,MODE_HIGH,Length,i)];
               double smin  =  Low[Lowest( NULL,0,MODE_LOW, Length,i)];
                      Bulls[i] = Price1 - smin;
                      Bears[i] = smax   - Price1;
               break;
            default :  /// as_adx mode
               Bulls[i] = 0.5*(MathAbs(High[i]  - High[i+1]) + (High[i]  - High[i+1]));
               Bears[i] = 0.5*(MathAbs(Low[i+1] - Low[i])    + (Low[i+1] - Low[i]));
               break;
         }

         SmthBulls[i] = iT3a(Bulls[i],Length,T3Hot,T3Original,T3Adaptive,i,0);    
         SmthBears[i] = iT3a(Bears[i],Length,T3Hot,T3Original,T3Adaptive,i,1);  
            if (OverBought > 0 && OverSold > 0 )
            {
               SigBulls[i] = OverBought/ 100 * (SmthBulls[i] + SmthBears[i]);
               SigBears[i] = OverSold  / 100 * (SmthBulls[i] + SmthBears[i]);
            }
            else
            {
               SigBulls[i] = iT3a(SmthBulls[i],Signal,T3Hot,T3Original,T3Adaptive,i,2);       
               SigBears[i] = iT3a(SmthBears[i],Signal,T3Hot,T3Original,T3Adaptive,i,3);  
            }
         }
         return(0);
      }
      
      //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);               
            SmthBulls[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,0,y);
            SmthBears[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,1,y);
            SigBulls[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,2,y);
            SigBears[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Mode,Length,Signal,T3Hot,T3Original,T3Adaptive,Price,OverBought,OverSold,3,y);
            
            //
            //
            //
            //
            //
       
            if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,TimeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int x = 1; x < n; x++)
               {
              
                  SmthBulls[i+x] = SmthBulls[i] + (SmthBulls[i+n] - SmthBulls[i]) * x/n;
                  SmthBears[i+x] = SmthBears[i] + (SmthBears[i+n] - SmthBears[i]) * x/n;
                  SigBulls[i+x]  = SigBulls[i]  + (SigBulls[i+n]  - SigBulls[i])  * x/n;
                  SigBears[i+x]  = SigBears[i]  + (SigBears[i+n]  - SigBears[i])  * x/n;
                  
               }               
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][28];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3a(double price, double period, double hot, bool original, bool adaptive, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
      if (adaptive)
      {
         workT3[r][_atr+buffer] = iATR(NULL,0,period,i);
            double max = workT3[r][_atr+buffer];
            double min = workT3[r][_atr+buffer];
            for (int k=1; k<period && (r-k>=0); k++)
               {
                  max = MathMax(max,workT3[r-k][_atr+buffer]);
                  min = MathMin(min,workT3[r-k][_atr+buffer]);
               }
            if (min!=max)
                  double atn = 1.0-(workT3[r][_atr+buffer]-min)/(max-min);
            else         atn = 0.5;
            period = period*(atn+1.0)/2.0;
      }
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}
     
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}     